package ee.tlu.evkk.api.controller;
import ee.tlu.evkk.api.dao.TestingTextsDao;
import ee.tlu.evkk.api.dao.UserDao;
import ee.tlu.evkk.api.dao.dto.TestingTexts;
import ee.tlu.evkk.api.dao.dto.User;
import org.springframework.web.bind.annotation.*;
import java.util.List;
import java.util.UUID;

@RestController
@RequestMapping("/texts")
public class TestingTextsController {
  private final TestingTextsDao testingTextsDao;
  private final UserDao userDao;
  public TestingTextsController(TestingTextsDao ttdao, UserDao ud){
      testingTextsDao=ttdao;
      userDao=ud;
  }
 
   @GetMapping("/loetelu")
  public List<TestingTexts> loetelu(){
      return testingTextsDao.findAll();
  }
  

   @GetMapping("/teade")
   public String tervitus(){
       return "tere";
   }

   @GetMapping("/korrutamine")
   public int korruta(int a, int b){
       return a*b;
   }  

   @PostMapping("/lisamine")
   public UUID lisa(String pealkiri, String sisu){
       TestingTexts t=new TestingTexts();
       t.setTitle(pealkiri);
       t.setContent(sisu);
       return testingTextsDao.insert(t);
   }
   @PostMapping("/kustutamine")
   public String kustuta(String kood){
      testingTextsDao.delete(UUID.fromString(kood));
       return kood.toString();
   }

   @GetMapping("/kasutaja")
   public User kysiKasutaja(){
       return userDao.findByEmailAddress("user0@localhost");
   }

   @GetMapping("/tekstikirje")
   public TestingTexts kysiTekst(){
       return testingTextsDao.findById(UUID.fromString("c1e26111-8953-4717-9895-c9c7a603030d"));
   }
}